FullScreen = LibStub("AceAddon-3.0"):NewAddon("Broker_Fullscreen", "AceEvent-3.0")
Broker_FullscreenDB = Broker_FullscreenDB or {}

local db = Broker_FullscreenDB
local FullScreen = FullScreen
local icon = "Interface\\Addons\\Broker_Fullscreen\\icon.tga"

local RestartGx = RestartGx
local GetCVar = GetCVar
local SetCVar = SetCVar
local text = {
	[0] = "Fullscreen",
	[1] = "Windowed",
}

function FullScreen:OnInitialize()
	db.max = GetCVar("gxMaximize")
	self:UpdateText()
end

function FullScreen:UpdateText()
	FullScreen.plugin.text = text[1 - GetCVar("gxWindow")]
end

function FullScreen:ToggleMode()
	local val = GetCVar("gxWindow")
	SetCVar("gxWindow", 1 - val)
	SetCVar("gxMaximize", 1 - db.max)
	self:UpdateText()
	RestartGx()
end

FullScreen.plugin = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Fullscreen", {
						type = "data source",
						icon = icon,
						label = "Broker_Fullscreen",
						text = "Fullscreen",
						OnTooltipShow = function(tooltip)
											if not tooltip or not tooltip.AddLine then return end
											tooltip:AddLine("")
											if GetCVar("gxWindow") == "1" then
												tooltip:AddLine("Left click to switch to full screen")
											else
												tooltip:AddLine("Left click to switch to windowed")
											end
										end,
						OnClick = function(frame, msg)
									if msg == "LeftButton" then
										FullScreen:ToggleMode()
									end
								end,
						})